#include <fract.h> // fract16, fract32

typedef struct	
{
	short	exp;
	fract16	frac;
} fastfloat16;

typedef struct	
{
	short	exp;
	fract32	frac;
} fastfloat32;


typedef struct 
{
	fastfloat16 real;
	fastfloat16 imag;
} complex_fastfloat16;
	
typedef struct 
{
	fastfloat32 real;
	fastfloat32 imag;
} complex_fastfloat32;

fastfloat16 mult_ff16(fastfloat16, fastfloat16);
fastfloat16 add_ff16(fastfloat16, fastfloat16);
fastfloat16 sub_ff16(fastfloat16, fastfloat16);
fastfloat16 div_ff16(fastfloat16, fastfloat16);

fastfloat16 float_to_ff16(float);
float ff16_to_float(fastfloat16);

fastfloat16 fract16_to_ff16(fract16);
fract16 ff16_to_fract16(fastfloat16);

fastfloat32 mult_ff32(fastfloat32, fastfloat32);
fastfloat32 add_ff32(fastfloat32, fastfloat32);
fastfloat32 sub_ff32(fastfloat32, fastfloat32);
fastfloat32 div_ff32(fastfloat32, fastfloat32);

fastfloat32 float_to_ff32(float);
float ff32_to_float(fastfloat32);

fastfloat32 fract32_to_ff32(fract32);
fract32 ff32_to_fract32(fastfloat32);
